#using scripts\codescripts\struct;

#using scripts\shared\callbacks_shared;
#using scripts\shared\system_shared;

#using scripts\shared\flag_shared;
// #using scripts\shared\array_shared;

#insert scripts\shared\shared.gsh;

#namespace clientids;

REGISTER_SYSTEM( "clientids", &__init__, undefined )
	
function __init__()
{
	callback::on_start_gametype( &init );
	callback::on_connect( &on_player_connect );
	// callback::on_spawned( &on_player_spawned ); // Call message function on init
}	

function init()
{
	// This is now handled in code ( not lan )
	// See s_nextScriptClientId 
	level.clientid = 0;
	// Set Client Dvars
	SetDvar("r_fog", "0"); // Disable fog
	SetDvar("r_dof_enable", "0"); // Disable depth of field
	SetDvar("r_lodbiasrigid", "-1000"); // Increase draw distance
	SetDvar("r_modellodbias", "10"); // Increase model draw distance
	level.perk_purchase_limit = 50; // Remove perk limit on most maps
	// level.player_starting_points = 500000; // DEBUG: Set player starting points
}

function on_player_connect()
{
	self.clientid = matchRecordNewPlayer( self );
	if ( !isdefined( self.clientid ) || self.clientid == -1 )
	{
		self.clientid = level.clientid;
		level.clientid++; // Is this safe? What if a server runs for a long time and many people join/leave
	}
}

/*
function on_player_spawned()
{
	// Spawn Message
	level flag::wait_till("initial_blackscreen_passed");
	self iPrintLnBold("Follow ^2@thahrimdon ^7on ^1YouTube ^7& ^6Twitch^7!");
	self thread print(); // Print message on knife
}

function print()
{
	for(;;)
	{
		if(self MeleeButtonPressed())
		{
			iPrintLnBold("Follow ^2@thahrimdon ^7on ^1YouTube ^7& ^6Twitch^7!");
			wait 1;
		}
		wait 0.05;
	}
}
*/
